diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/spectrum-interference-test.cc ns-3.42/src/spectrum/test/spectrum-interference-test.cc
--- ns-3.41/src/spectrum/test/spectrum-interference-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/spectrum-interference-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -152,7 +152,7 @@
 };
 
 SpectrumInterferenceTestSuite::SpectrumInterferenceTestSuite()
-    : TestSuite("spectrum-interference", UNIT)
+    : TestSuite("spectrum-interference", Type::UNIT)
 {
     NS_LOG_INFO("creating SpectrumInterferenceTestSuite");
 
@@ -184,32 +184,32 @@
     (*s1)[1] = 7.204059965732e-16;
     b = 10067205.5632012;
     AddTestCase(new SpectrumInterferenceTestCase(s1, 0, true, "sdBm  = [-46 -48]  tx bytes: 1"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s1,
                                                  static_cast<uint32_t>(b * 0.5 + 0.5),
                                                  true,
                                                  "sdBm  = [-46 -48]  tx bytes: b*0.5"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s1,
                                                  static_cast<uint32_t>(b * (1 - e) + 0.5),
                                                  true,
                                                  "sdBm  = [-46 -48]  tx bytes: b*(1-e)"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s1,
                                                  static_cast<uint32_t>(b * (1 + e) + 0.5),
                                                  false,
                                                  "sdBm  = [-46 -48]  tx bytes: b*(1+e)"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s1,
                                                  static_cast<uint32_t>(b * 1.5 + 0.5),
                                                  false,
                                                  "sdBm  = [-46 -48]  tx bytes: b*1.5"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s1,
                                                  0xffffffff,
                                                  false,
                                                  "sdBm  = [-46 -48]  tx bytes: 2^32-1"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     // Power Spectral Density of the signal of interest  =  [-63 -61] dBm;
     Ptr<SpectrumValue> s2 = Create<SpectrumValue>(m);
@@ -217,32 +217,32 @@
     (*s2)[1] = 3.610582885110e-17;
     b = 882401.591840728;
     AddTestCase(new SpectrumInterferenceTestCase(s2, 1, true, "sdBm  = [-63 -61]  tx bytes: 1"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s2,
                                                  static_cast<uint32_t>(b * 0.5 + 0.5),
                                                  true,
                                                  "sdBm  = [-63 -61]  tx bytes: b*0.5"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s2,
                                                  static_cast<uint32_t>(b * (1 - e) + 0.5),
                                                  true,
                                                  "sdBm  = [-63 -61]  tx bytes: b*(1-e)"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s2,
                                                  static_cast<uint32_t>(b * (1 + e) + 0.5),
                                                  false,
                                                  "sdBm  = [-63 -61]  tx bytes: b*(1+e)"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s2,
                                                  static_cast<uint32_t>(b * 1.5 + 0.5),
                                                  false,
                                                  "sdBm  = [-63 -61]  tx bytes: b*1.5"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumInterferenceTestCase(s2,
                                                  0xffffffff,
                                                  false,
                                                  "sdBm  = [-63 -61]  tx bytes: 2^32-1"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/spectrum-value-test.cc ns-3.42/src/spectrum/test/spectrum-value-test.cc
--- ns-3.41/src/spectrum/test/spectrum-value-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/spectrum-value-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -105,7 +105,7 @@
 };
 
 SpectrumValueTestSuite::SpectrumValueTestSuite()
-    : TestSuite("spectrum-value", UNIT)
+    : TestSuite("spectrum-value", Type::UNIT)
 {
     // NS_LOG_INFO("creating SpectrumValueTestSuite");
 
@@ -203,10 +203,10 @@
     tv5 = v1 * v2;
     tv6 = v1 / v2;
 
-    AddTestCase(new SpectrumValueTestCase(tv3, v3, "tv3 = v1 + v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv4, v4, "tv4 = v1 - v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv5, v5, "tv5 = v1 * v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv6, v6, "tv6 = v1 div v2"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv3, v3, "tv3 = v1 + v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv4, v4, "tv4 = v1 - v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv5, v5, "tv5 = v1 * v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv6, v6, "tv6 = v1 div v2"), TestCase::Duration::QUICK);
 
     // std::cerr << v6 << std::endl;
     // std::cerr << tv6 << std::endl;
@@ -221,10 +221,10 @@
     tv5 *= v2;
     tv6 /= v2;
 
-    AddTestCase(new SpectrumValueTestCase(tv3, v3, "tv3 += v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv4, v4, "tv4 -= v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv5, v5, "tv5 *= v2"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv6, v6, "tv6 div= v2"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv3, v3, "tv3 += v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv4, v4, "tv4 -= v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv5, v5, "tv5 *= v2"), TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv6, v6, "tv6 div= v2"), TestCase::Duration::QUICK);
 
     SpectrumValue tv7a(f);
     SpectrumValue tv8a(f);
@@ -234,11 +234,14 @@
     tv8a = v1 - doubleValue;
     tv9a = v1 * doubleValue;
     tv10a = v1 / doubleValue;
-    AddTestCase(new SpectrumValueTestCase(tv7a, v7, "tv7a = v1 + doubleValue"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv8a, v8, "tv8a = v1 - doubleValue"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv9a, v9, "tv9a = v1 * doubleValue"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv7a, v7, "tv7a = v1 + doubleValue"),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv8a, v8, "tv8a = v1 - doubleValue"),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv9a, v9, "tv9a = v1 * doubleValue"),
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumValueTestCase(tv10a, v10, "tv10a = v1 div doubleValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     SpectrumValue tv7b(f);
     SpectrumValue tv8b(f);
@@ -248,11 +251,14 @@
     tv8b = doubleValue - v1;
     tv9b = doubleValue * v1;
     tv10b = doubleValue / v1;
-    AddTestCase(new SpectrumValueTestCase(tv7b, v7, "tv7b =  doubleValue + v1"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv8b, v8, "tv8b =  doubleValue - v1"), TestCase::QUICK);
-    AddTestCase(new SpectrumValueTestCase(tv9b, v9, "tv9b =  doubleValue * v1"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv7b, v7, "tv7b =  doubleValue + v1"),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv8b, v8, "tv8b =  doubleValue - v1"),
+                TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv9b, v9, "tv9b =  doubleValue * v1"),
+                TestCase::Duration::QUICK);
     AddTestCase(new SpectrumValueTestCase(tv10b, v10, "tv10b = doubleValue div v1"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     SpectrumValue v1ls3(f);
     SpectrumValue v1rs3(f);
@@ -262,12 +268,14 @@
     v1ls3[0] = v1[3];
     v1ls3[1] = v1[4];
     tv1ls3 = v1 << 3;
-    AddTestCase(new SpectrumValueTestCase(tv1ls3, v1ls3, "tv1ls3 = v1 << 3"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv1ls3, v1ls3, "tv1ls3 = v1 << 3"),
+                TestCase::Duration::QUICK);
 
     v1rs3[3] = v1[0];
     v1rs3[4] = v1[1];
     tv1rs3 = v1 >> 3;
-    AddTestCase(new SpectrumValueTestCase(tv1rs3, v1rs3, "tv1rs3 = v1 >> 3"), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(tv1rs3, v1rs3, "tv1rs3 = v1 >> 3"),
+                TestCase::Duration::QUICK);
 }
 
 /**
@@ -282,7 +290,7 @@
 };
 
 SpectrumConverterTestSuite::SpectrumConverterTestSuite()
-    : TestSuite("spectrum-converter", UNIT)
+    : TestSuite("spectrum-converter", Type::UNIT)
 {
     double f;
 
@@ -314,7 +322,7 @@
     //   NS_LOG_LOGIC(t12);
     //   NS_LOG_LOGIC(*res);
 
-    AddTestCase(new SpectrumValueTestCase(t12, *res, ""), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(t12, *res, ""), TestCase::Duration::QUICK);
     // TEST_ASSERT(MoreOrLessEqual(t12, *res));
 
     Ptr<SpectrumValue> v2a = Create<SpectrumValue>(sof2);
@@ -326,7 +334,7 @@
     //   NS_LOG_LOGIC(*v2a);
     //   NS_LOG_LOGIC(t21a);
     //   NS_LOG_LOGIC(*res);
-    AddTestCase(new SpectrumValueTestCase(t21a, *res, ""), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(t21a, *res, ""), TestCase::Duration::QUICK);
     // TEST_ASSERT(MoreOrLessEqual(t21a, *res));
 
     Ptr<SpectrumValue> v2b = Create<SpectrumValue>(sof2);
@@ -345,7 +353,7 @@
     //   NS_LOG_LOGIC(*v2b);
     //   NS_LOG_LOGIC(t21b);
     //   NS_LOG_LOGIC(*res);
-    AddTestCase(new SpectrumValueTestCase(t21b, *res, ""), TestCase::QUICK);
+    AddTestCase(new SpectrumValueTestCase(t21b, *res, ""), TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/spectrum-waveform-generator-test.cc ns-3.42/src/spectrum/test/spectrum-waveform-generator-test.cc
--- ns-3.41/src/spectrum/test/spectrum-waveform-generator-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/spectrum-waveform-generator-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -127,14 +127,14 @@
 };
 
 WaveformGeneratorTestSuite::WaveformGeneratorTestSuite()
-    : TestSuite("waveform-generator", SYSTEM)
+    : TestSuite("waveform-generator", Type::SYSTEM)
 {
     NS_LOG_INFO("creating WaveformGeneratorTestSuite");
 
     // Stop while wave is active
-    AddTestCase(new WaveformGeneratorTestCase(1.0, 0.5, 1.2), TestCase::QUICK);
+    AddTestCase(new WaveformGeneratorTestCase(1.0, 0.5, 1.2), TestCase::Duration::QUICK);
     // Stop after wave
-    AddTestCase(new WaveformGeneratorTestCase(1.0, 0.5, 1.7), TestCase::QUICK);
+    AddTestCase(new WaveformGeneratorTestCase(1.0, 0.5, 1.7), TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.42/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.41/src/spectrum/test/three-gpp-channel-test-suite.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/three-gpp-channel-test-suite.cc	2024-05-29 15:29:47.172073600 -0700
@@ -498,6 +498,234 @@
 
 /**
  * \ingroup spectrum-tests
+ *
+ * Test case for the ThreeGppChannelModel class.
+ * It checks if the channel realizations are correctly
+ * updated after a change in the number of antenna elements.
+ */
+class ThreeGppAntennaSetupChangedTest : public TestCase
+{
+  public:
+    /**
+     * Constructor
+     */
+    ThreeGppAntennaSetupChangedTest();
+
+    /**
+     * Destructor
+     */
+    ~ThreeGppAntennaSetupChangedTest() override;
+
+  private:
+    /**
+     * Build the test scenario
+     */
+    void DoRun() override;
+
+    /**
+     * This method is used to schedule the channel matrix computation at different
+     * time instants and to check if it correctly updated
+     * \param channelModel the ThreeGppChannelModel object used to generate the channel matrix
+     * \param txMob the mobility model of the first node
+     * \param rxMob the mobility model of the second node
+     * \param txAntenna the antenna object associated to the first node
+     * \param rxAntenna the antenna object associated to the second node
+     * \param update whether if the channel matrix should be updated or not
+     */
+    void DoGetChannel(Ptr<ThreeGppChannelModel> channelModel,
+                      Ptr<MobilityModel> txMob,
+                      Ptr<MobilityModel> rxMob,
+                      Ptr<PhasedArrayModel> txAntenna,
+                      Ptr<PhasedArrayModel> rxAntenna,
+                      bool update);
+
+    Ptr<const ThreeGppChannelModel::ChannelMatrix>
+        m_currentChannel;            //!< used by DoGetChannel to store the current channel matrix
+    uint32_t m_txAntennaElements{4}; //!< number of rows and columns of tx antenna array
+    uint32_t m_rxAntennaElements{4}; //!< number of rows and columns of rx antenna array
+    uint32_t m_txPorts{1}; //!< number of horizontal and vertical ports of tx antenna array
+    uint32_t m_rxPorts{1}; //!< number of horizontal and vertical ports of rx antenna array
+};
+
+ThreeGppAntennaSetupChangedTest::ThreeGppAntennaSetupChangedTest()
+    : TestCase("Check if the channel realizations are correctly updated after antenna port changes "
+               "during the simulation")
+{
+}
+
+ThreeGppAntennaSetupChangedTest::~ThreeGppAntennaSetupChangedTest()
+{
+}
+
+void
+ThreeGppAntennaSetupChangedTest::DoGetChannel(Ptr<ThreeGppChannelModel> channelModel,
+                                              Ptr<MobilityModel> txMob,
+                                              Ptr<MobilityModel> rxMob,
+                                              Ptr<PhasedArrayModel> txAntenna,
+                                              Ptr<PhasedArrayModel> rxAntenna,
+                                              bool update)
+{
+    // retrieve the channel matrix
+    Ptr<const ThreeGppChannelModel::ChannelMatrix> channelMatrix =
+        channelModel->GetChannel(txMob, rxMob, txAntenna, rxAntenna);
+
+    if (m_currentChannel)
+    {
+        // compare the old and the new channel matrices
+        NS_TEST_ASSERT_MSG_EQ((m_currentChannel->m_channel != channelMatrix->m_channel),
+                              update,
+                              Simulator::Now().GetMilliSeconds()
+                                  << " The channel matrix is not correctly updated");
+    }
+    m_currentChannel = channelMatrix;
+}
+
+void
+ThreeGppAntennaSetupChangedTest::DoRun()
+{
+    // Build the scenario for the test
+    uint32_t updatePeriodMs = 100; // update period in ms
+
+    // create the channel condition model
+    Ptr<ChannelConditionModel> channelConditionModel =
+        CreateObject<AlwaysLosChannelConditionModel>();
+
+    // create the ThreeGppChannelModel object used to generate the channel matrix
+    Ptr<ThreeGppChannelModel> channelModel = CreateObject<ThreeGppChannelModel>();
+    channelModel->SetAttribute("Frequency", DoubleValue(60.0e9));
+    channelModel->SetAttribute("Scenario", StringValue("UMa"));
+    channelModel->SetAttribute("ChannelConditionModel", PointerValue(channelConditionModel));
+    channelModel->SetAttribute("UpdatePeriod", TimeValue(MilliSeconds(updatePeriodMs)));
+
+    // create the tx and rx nodes
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    // create the tx and rx devices
+    Ptr<SimpleNetDevice> txDev = CreateObject<SimpleNetDevice>();
+    Ptr<SimpleNetDevice> rxDev = CreateObject<SimpleNetDevice>();
+
+    // associate the nodes and the devices
+    nodes.Get(0)->AddDevice(txDev);
+    txDev->SetNode(nodes.Get(0));
+    nodes.Get(1)->AddDevice(rxDev);
+    rxDev->SetNode(nodes.Get(1));
+
+    // create the tx and rx mobility models and set their positions
+    Ptr<MobilityModel> txMob = CreateObject<ConstantPositionMobilityModel>();
+    txMob->SetPosition(Vector(0.0, 0.0, 10.0));
+    Ptr<MobilityModel> rxMob = CreateObject<ConstantPositionMobilityModel>();
+    rxMob->SetPosition(Vector(100.0, 0.0, 1.6));
+
+    // associate the nodes and the mobility models
+    nodes.Get(0)->AggregateObject(txMob);
+    nodes.Get(1)->AggregateObject(rxMob);
+
+    // create the tx and rx antennas and set the their dimensions
+    Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
+        "NumColumns",
+        UintegerValue(m_txAntennaElements),
+        "NumRows",
+        UintegerValue(m_txAntennaElements),
+        "AntennaElement",
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_txPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_txPorts));
+
+    Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray>(
+        "NumColumns",
+        UintegerValue(m_rxAntennaElements),
+        "NumRows",
+        UintegerValue(m_rxAntennaElements),
+        "AntennaElement",
+        PointerValue(CreateObject<IsotropicAntennaModel>()),
+        "NumVerticalPorts",
+        UintegerValue(m_rxPorts),
+        "NumHorizontalPorts",
+        UintegerValue(m_rxPorts));
+
+    // check if the channel matrix is correctly updated
+
+    // compute the channel matrix for the first time
+    Simulator::Schedule(MilliSeconds(1),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        true);
+
+    // call GetChannel before the update period is exceeded, the channel matrix
+    // should not be updated
+    Simulator::Schedule(MilliSeconds(2),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        false);
+
+    // after changing the number of antenna ports, the channel matrix
+    // should be recomputed
+    Simulator::Schedule(MilliSeconds(3),
+                        [&txAntenna]() { txAntenna->SetNumRows(txAntenna->GetNumRows() + 1); });
+    Simulator::Schedule(MilliSeconds(4),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        true);
+
+    // after recomputing it once, the channel matrix should be cached
+    Simulator::Schedule(MilliSeconds(5),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        false);
+
+    // after recomputing it once, the channel matrix should be cached
+    Simulator::Schedule(MilliSeconds(6),
+                        [&rxAntenna]() { rxAntenna->SetNumRows(rxAntenna->GetNumRows() + 1); });
+    Simulator::Schedule(MilliSeconds(7),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        true);
+
+    // after recomputing it once, the channel matrix should be cached
+    Simulator::Schedule(MilliSeconds(8),
+                        &ThreeGppAntennaSetupChangedTest::DoGetChannel,
+                        this,
+                        channelModel,
+                        txMob,
+                        rxMob,
+                        txAntenna,
+                        rxAntenna,
+                        false);
+
+    Simulator::Run();
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup spectrum-tests
  * \brief A structure that holds the parameters for the function
  * CheckLongTermUpdate. In this way the problem with the limited
  * number of parameters of method Schedule is avoided.
@@ -1228,22 +1456,27 @@
 };
 
 ThreeGppChannelTestSuite::ThreeGppChannelTestSuite()
-    : TestSuite("three-gpp-channel", UNIT)
+    : TestSuite("three-gpp-channel", Type::UNIT)
 {
-    AddTestCase(new ThreeGppChannelMatrixComputationTest(2, 2, 1, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 2, 1, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixComputationTest(2, 2, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 4, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 2, 2, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 4, 1, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 2, 1, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 4, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 2, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 4, 1, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 4, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 2, 2, 2), TestCase::QUICK);
-    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 2, 2, 1), TestCase::QUICK);
-    AddTestCase(new ThreeGppCalcLongTermMultiPortTest(), TestCase::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixComputationTest(2, 2, 1, 1), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 2, 1, 1), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixComputationTest(2, 2, 2, 2), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 4, 2, 2), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixComputationTest(4, 2, 2, 1), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 4, 1, 1), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 2, 1, 1), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 4, 2, 2), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppChannelMatrixUpdateTest(2, 2, 2, 2), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppAntennaSetupChangedTest(), TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 4, 1, 1),
+                TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 4, 2, 2),
+                TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 2, 2, 2),
+                TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppSpectrumPropagationLossModelTest(4, 2, 2, 1),
+                TestCase::Duration::QUICK);
+    AddTestCase(new ThreeGppCalcLongTermMultiPortTest(), TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antennas are configured face-to-face.
@@ -1263,7 +1496,7 @@
                                                  MimoPolarizationAntennaParams(false, 0, M_PI),
                                                  testChannel1,
                                                  0.9),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antennas are configured face-to-face.
@@ -1282,7 +1515,7 @@
                                          MimoPolarizationAntennaParams(false, 0, M_PI),
                                          {5, 5, 3, 3, 5, 5, 3, 3, 3, 3, -5, -5, 3, 3, -5, -5},
                                          0.8),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antennas are configured face-to-face.
@@ -1301,7 +1534,7 @@
                                          MimoPolarizationAntennaParams(false, 0, M_PI),
                                          {4, 4, 4, 4, 4, 4, 4, 4, 4, 4, -4, -4, 4, 4, -4, -4},
                                          0.7),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antennas are configured face-to-face.
@@ -1320,7 +1553,7 @@
                     MimoPolarizationAntennaParams(false, 0, M_PI),
                     {0, 0, 5.8, 5.8, 0, 0, 5.8, 5.8, 5.9, 5.9, 0, 0, 5.9, 5.9, 0, 0},
                     0.9),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antennas are face to face. We test the configuration of
@@ -1344,7 +1577,7 @@
                                          MimoPolarizationAntennaParams(false, 0, -(M_PI / 4) * 3),
                                          testChannel1,
                                          0.9),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
 
     /**
      *  The TX and RX antenna have different height.
@@ -1379,7 +1612,7 @@
                      {-2.4, 4},
                      {-2.4, 4}},
                     0.5),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 /// Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/tv-helper-distribution-test.cc ns-3.42/src/spectrum/test/tv-helper-distribution-test.cc
--- ns-3.41/src/spectrum/test/tv-helper-distribution-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/tv-helper-distribution-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -144,12 +144,13 @@
 };
 
 TvHelperDistributionTestSuite::TvHelperDistributionTestSuite()
-    : TestSuite("tv-helper-distribution", UNIT)
+    : TestSuite("tv-helper-distribution", Type::UNIT)
 {
     NS_LOG_INFO("creating TvHelperDistributionTestSuite");
     for (uint32_t maxNumTransmitters = 3; maxNumTransmitters <= 203; maxNumTransmitters += 10)
     {
-        AddTestCase(new TvHelperDistributionTestCase(maxNumTransmitters), TestCase::QUICK);
+        AddTestCase(new TvHelperDistributionTestCase(maxNumTransmitters),
+                    TestCase::Duration::QUICK);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/tv-spectrum-transmitter-test.cc ns-3.42/src/spectrum/test/tv-spectrum-transmitter-test.cc
--- ns-3.41/src/spectrum/test/tv-spectrum-transmitter-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/tv-spectrum-transmitter-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -181,7 +181,7 @@
 };
 
 TvSpectrumTransmitterTestSuite::TvSpectrumTransmitterTestSuite()
-    : TestSuite("tv-spectrum-transmitter", UNIT)
+    : TestSuite("tv-spectrum-transmitter", Type::UNIT)
 {
     NS_LOG_INFO("creating TvSpectrumTransmitterTestSuite");
     for (double startFreq = 100; startFreq < 1e15; startFreq *= 10)
@@ -194,7 +194,7 @@
                                                               bandwidth,
                                                               psd,
                                                               TvSpectrumTransmitter::TVTYPE_8VSB),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
             }
         }
     }
@@ -208,7 +208,7 @@
                                                               bandwidth,
                                                               psd,
                                                               TvSpectrumTransmitter::TVTYPE_COFDM),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
             }
         }
     }
@@ -222,7 +222,7 @@
                                                               bandwidth,
                                                               psd,
                                                               TvSpectrumTransmitter::TVTYPE_ANALOG),
-                            TestCase::QUICK);
+                            TestCase::Duration::QUICK);
             }
         }
     }
